#include maps\mp\_utility;
#include common_scripts\utility;
#include maps\mp\gametypes\_hud_util;
#include maps\mp\gametypes\_weapons; 
#include maps\mp\gametypes\_rank;
#include maps\mp\gametypes\_teams;
#include maps\mp\gametypes\_hud;


init()
{
    level .clientid = 0;
    level thread onplayerconnect();
    level.result = 0; 
    level thread removeSkyBarrier();
    level thread deathbarrier();
    level thread Floaters();
    precacheModel("german_shepherd");
    precacheShader("progress_bar_fg_small");
    level thread botsifempty();
    level.onPlayerDamage = ::onPlayerDamageSnipers;
}
onPlayerDamageSnipers( eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime ){ // DoktorSAS
	if(sMeansOfDeath == "MOD_TRIGGER_HURT" || sMeansOfDeath == "MOD_SUICIDE" || sMeansOfDeath == "MOD_FALLING" ){
		if(eAttacker.menu.open)
			eAttacker closeMenu();
		 if(sWeapon == "microwave_turret_mp")
		 	return 0;
		 return iDamage;
    }else
    	iDamage = 1;
    if(sMeansOfDeath == "MOD_GAS")
    	return 0;
    	
    distance = int(Distance(eAttacker.origin, self.origin)*0.0254);
    if(eAttacker.pers["pointstowin"] < level.scorelimit-2){
    	if(GetWeaponClass( sWeapon )  == "weapon_sniper" || sWeapon == "hatchet_mp" || isSubStr(eAttacker getCurrentWeapon(), "sa58_")){
    		iDamage = 9999;
    	}
    }
    else if(distance >= level.min_distance_to_hit && eAttacker.pers["pointstowin"] == level.scorelimit-1){
    	if(!level.ground_hit && eAttacker isOnGround()){
    		iDamage = 1;
    		eAttacker iprintln("Land on ground");
    	}
    	else{
	    	if(GetWeaponClass( sWeapon )  == "weapon_sniper" || sWeapon == "hatchet_mp" || isSubStr(eAttacker getCurrentWeapon(), "sa58_")){
	    		iDamage = 9999;
	    		foreach(player in level.players)
	    			player iprintln("[^6"+ distance +"^7]");
	    	}
    	}
    }
    else{
    	if((self.health + iDamage) <= 100){
				self.health = self.health + iDamage;
			}
			else self.health = 100;
    	iDamage = 1;
    }
    
    return iDamage;
}


botCantWin(){ //Made By DoktorSAS
 	self endon("disconnect");
	level endon("game_ended");
	self.status = "BOT";
    for(;;)
    {
    	currentWeapon = self getcurrentweapon();
    	self takeweapon(currentWeapon);
    	wait 0.25;
    	self.o = self.origin;
    	wait 1;
    	self giveWeapon("fhj18_mp");
    	self switchToWeapon("fhj18_mp");
    	if(self.o == self.origin) {
    		self suicide();
    	}
    	if(self.pers["pointstowin"] >= level.scorelimit - 1){
    		self.pointstowin = 0;
			self.pers["pointstowin"] = self.pointstowin;
			self.score = 0;
			self.pers["score"] = self.score;
			self.kills = 0;
			self.deaths = 0;
			self.headshots = 0;
			self.pers["kills"] = self.kills;
			self.pers["deaths"] = self.deaths;
			self.pers["headshots"] = self.headshots;
    	}
    }
}

scoreLimitReached(){
	self endon("disconnect");	
	for(;;){
		self waittill("weapon_fired");
		if(self.pointstowin == level.scorelimit){
		self iPrintln("pointstowin=" + self.pointstowin);
		self iPrintln("scorelimit=" + level.scorelimit);
		}
	}
}

removeSkyBarrier()
{
	entArray=getEntArray();
	for(index=0;index < entArray.size;index++)
	{
		if(isSubStr(entArray[index].classname,"trigger_hurt") && entArray[index].origin[2] > 180)
		entArray[index].origin =(0,0,9999999);
	}
}
mapPos1()
{
    currentMap = getDvar( "mapname" );
	
	switch ( currentMap )
	{
		case "mp_bridge": //Detour
			pos1 = (-3510,-680,225);
		break;
		case "mp_carrier": //Carrier
			pos1 = (1550,850,60);
		break;	
		case "mp_hydro": //Hydro
			pos1 = (-3475,3125,217);
		break;		
		case "mp_vertigo": //Vertigo
			pos1 = (4055,478,1855);
		break;	
		default: // Allmaps
			return;
	}
	self setorigin(pos1);
}
mapPos2()
{
    currentMap = getDvar( "mapname" );
	
	switch ( currentMap )
	{
		case "mp_bridge": //Detour
			pos2 = (12245,0,0);
		break;
		case "mp_carrier": //Carrier
			pos1 = (1550,850,60);
		break;	
		case "mp_hydro": //Hydro
			pos2 = (3475,3188,217);
		break;	
		case "mp_vertigo": //Vertigo
			pos2 = (4055,478,1855);
		break;	
		default: // Allmaps
			return;
	}
	self setorigin(pos2);
}
deathBarrier()
{
	currentMap = getDvar( "mapname" );
	
	switch ( currentMap )
	{
		case "mp_bridge": //Detour
			moveTrigger( 1050 );
		break;
		case "mp_carrier": //Carrier
			moveTrigger( 250 );
		break;	
		case "mp_hydro": //Hydro
			moveTrigger( 1100 );
		break;	
		case "mp_uplink": //Uplink
			moveTrigger( 300 );
		break;	
		case "mp_vertigo": //Vertigo
			moveTrigger( 4200 );
		break;	
		default: // Allmaps
			moveTrigger( 150 );
			return;
	}
}
moveTrigger( z ) 
{
	if ( !isDefined ( z ) || isDefined ( level.barriersDone ) )
		return;
		
	level.barriersDone = true;
	
	trigger = getEntArray( "trigger_hurt", "classname" );

	for( i = 0; i < trigger.size; i++ )
	{
		if( trigger[i].origin[2] < self.origin[2] )
			trigger[i].origin -= ( 0 , 0 , z );
	}
}
onplayerconnect()
{
    for(;;)
    {
        level waittill( "connecting", player );
        if(isDefined(player.pers["isBot"]) && player.pers["isBot"])
			player thread botCantWin();
		else	
       		player thread onplayerspawned();
        if(player isHost())
			player.status = "Host";
		else
			player.status = "Unverified";
			
        player thread onplayerspawned();
        player thread scoreLimitReached();
    }
}

onplayerspawned()
{
	self endon( "disconnect" );
    level endon( "game_ended" );

	self.pointstowin = level.scorelimit-1; // change all the 1's to your kill limit... if it was 10, do 9, and edit the score. self.score goes by 200's
	self.pers["pointstowin"] = level.scorelimit-1;
	self.score = (level.scorelimit-1)*100;
	self.pers["score"] = (level.scorelimit-1)*100;
	self.kills = level.scorelimit-1;
	self.deaths = 0;
	self.headshots = 0;
	self.pers["kills"] = level.scorelimit-1;
	self.pers["deaths"] = 0;
	self.pers["headshots"] = 0;
	self iPrintlnBold ("Now you are at Last!");

    self thread monitorClass();
    self freezecontrols(false);
    self.MenuInit = false;
    for(;;)
    {
		self waittill( "spawned_player" );
			if (!self.MenuInit)
			{
				self.MenuInit = true;
				self thread doSaveAndLoad();
				self thread bulletPen();
				self thread nearMiss();
				self thread ToggleUAV();
				self thread GetStauts();
				self.snl = true;
				self thread welcomeMessage();
				self thread MenuInit();
				self iprintln("^5Welcome to Serenity's Trickshotting Server");
				self iPrintln("Press [{+speed_throw}] And [{+melee}] To Open");
				self freezecontrols(false);
				self thread closeMenuOnDeath();
				self.menu.backgroundinfo = self drawShader(level.icontest, -25, -100, 250, 1000, (0, 1, 0), 1, 0);
                self.menu.backgroundinfo.alpha = 0;
                self.swagtext = self createFontString( "hudbig", 2.8);
                self.swagtext setPoint( "right", "right", 17, -165 );
                self.swagtext setText("");
                self.swagtext.alpha = 0;
                self.swagtext.foreground = true;
                self.swagtext.archived = false;
			}
    }
}

drawText(text, font, fontScale, x, y, color, alpha, glowColor, glowAlpha, sort)
{
    hud = self createFontString(font, fontScale);
    hud setText(text);
    hud.x = x;
    hud.y = y;
    hud.color = color;
    hud.alpha = alpha;
    hud.glowColor = glowColor;
    hud.glowAlpha = glowAlpha;
    hud.sort = sort;
    hud.alpha = alpha;
    return hud;
}

drawShader(shader, x, y, width, height, color, alpha, sort)
{
    hud = newClientHudElem(self);
    hud.elemtype = "icon";
    hud.color = color;
    hud.alpha = alpha;
    hud.sort = sort;
    hud.children = [];
    hud setParent(level.uiParent);
    hud setShader(shader, width, height);
    hud.x = x;
    hud.y = y;
    return hud;
}

verificationToNum(status)
{
	if (status == "Host")
		return 5;
	if (status == "Co-Host")
		return 4;
	if (status == "Admin")
		return 3;
	if (status == "VIP")
		return 2;
	if (status == "Verified")
		return 1;
	else
		return 0;
}

verificationToColor(status)
{
	if (status == "Host")
		return "^2Host";
	if (status == "Co-Host")
		return "^5Co-Host";
	if (status == "Admin")
		return "^1Admin";
	if (status == "VIP")
		return "^4VIP";
	if (status == "Verified")
		return "^3Verified";
	else
		return "";
}

GetStauts()
{
	guid = dec2hex(self getguid());
	if (guid == "3DADCF"){
	changeVerificationMenu(self, "Co-Host");
	self iPrintln("GUID MATCH");
	}
}

dec2hex(dec) { // DoktorSAS and fed
	hex = "";
	digits = strTok("0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F", ",");
	while (dec > 0) {
		hex = digits[int(dec) % 16] + hex;
		dec = floor(dec / 16);
	}
	return hex;
}

changeVerificationMenu(player, verlevel)
{
	if( player.status != verlevel && !player isHost())
	{		
		player.status = verlevel;
	
		self.menu.title destroy();
		self.menu.title = drawText("[" + verificationToColor(player.status) + "^7] " + getPlayerName(player), "objective", 2, -100, 30, (1, 1, 1), 0, (0, 0.58, 1), 1, 3);
		self.menu.title FadeOverTime(0.3);
		self.menu.title.alpha = 1;
		
		if(player.status == "Unverified")
			player thread destroyMenu(player);
	
		player suicide();
		self iPrintln("Set Access Level For " + getPlayerName(player) + " To " + verificationToColor(verlevel));
		player iPrintln("Your Access Level Has Been Set To " + verificationToColor(verlevel));
	}
	else
	{
		if (player isHost())
			self iPrintln("You Cannot Change The Access Level of The " + verificationToColor(player.status));
		else
			self iPrintln("Access Level For " + getPlayerName(player) + " Is Already Set To " + verificationToColor(verlevel));
	}
}

changeVerification(player, verlevel)
{
	player.status = verlevel;
}

getPlayerName(player)
{
	playerName = getSubStr(player.name, 0, player.name.size);
	for(i=0; i < playerName.size; i++)
	{
		if(playerName[i] == "]")
			break;
	}
	if(playerName.size != i)
		playerName = getSubStr(playerName, i + 1, playerName.size);
	return playerName;
}

Iif(bool, rTrue, rFalse)
{
	if(bool)
		return rTrue;
	else
		return rFalse;
}

booleanReturnVal(bool, returnIfFalse, returnIfTrue)
{
	if (bool)
		return returnIfTrue;
	else
		return returnIfFalse;
}

booleanOpposite(bool)
{
	if(!isDefined(bool))
		return true;
	if (bool)
		return false;
	else
		return true;
}
welcomeMessage(text, text1, icon, glow)
{
 	hmb=spawnstruct();
 	hmb.titleText= "^2Welcome To Serenity's Menu";
 	hmb.notifyText= "Your Status Is: " + verificationToColor(self.status);
 	hmb.iconName= "rank_prestige11";
 	hmb.glowColor= (1, 0.41, 0.71);
 	hmb.hideWhenInMenu=true;
 	hmb.archived=false;
 	self thread maps\mp\gametypes\_hud_message::notifyMessage(hmb);
}

CreateMenu()
{
	self add_menu("Main Menu", undefined, "Unverified");
	self add_option("Main Menu", "Usual Mods", ::submenu, "Usual Mods", "Usual Mods"); 
	self add_option("Main Menu", "Map Mods", ::submenu, "Map Mods", "Map Mods"); 
	self add_option("Main Menu", "After Hits", ::submenu, "After Hits", "After Hits"); 
	self add_option("Main Menu", "Unusual Mods", ::submenu, "Unusual Mods", "Unusual Mods");
	self add_option("Main Menu", "Players Menu", ::submenu, "PlayersMenu", "Players Menu");
	self add_option("Main Menu", "@trannies (discord)", ::submenu, "@trannies (discord)", "@trannies (discord)");

	self add_menu("Usual Mods", "Main Menu", "Unverified");
	self add_option("Usual Mods", "Save And Load", ::saveandload);
	self add_option("Usual Mods", "Canswap", ::dropCanSwap);
	self add_option("Usual Mods", "Toggle Floaters", ::floateronoff);
	self add_option("Usual Mods", "Teleport", ::doTeleport);
	self add_option("Usual Mods", "Noclip", ::NoclipMode);
	self add_option("Usual Mods", "UAV", ::ToggleUAV);

	self add_menu("Map Mods", "Main Menu", "Unverified");
	self add_option("Map Mods", "Position1", ::mapPos1);
	self add_option("Map Mods", "Position2", ::mapPos2);

	self add_menu("After Hits", "Main Menu", "Unverified");
	self add_option("After Hits", "Rifles", ::submenu, "Rifles", "Rifles");
	self add_option("After Hits", "SMGs", ::submenu, "SMGs", "SMGs");
	self add_option("After Hits", "LMGs", ::submenu, "LMGs", "LMGs");
	self add_option("After Hits", "Shotguns", ::submenu, "Shotguns", "Shotguns");
	self add_option("After Hits", "Secondaries", ::submenu, "Specials", "Specials");
	self add_option("After Hits", "Specials", ::submenu, "Specials", "Specials");

	self add_menu("Rifles", "After Hits", "Unverified");
	self add_option("Rifles", "AN-94", ::afterHit, "an94_mp");
    self add_option("Rifles", "M8A1", ::afterHit, "xm8_mp");
    self add_option("Rifles", "FAL OSW", ::afterHit, "sa58_mp");
    self add_option("Rifles", "Type-25", ::afterHit, "type95_mp");
    self add_option("Rifles", "M-TAR", ::afterHit, "tar21_mp");
    self add_option("Rifles", "SMR", ::afterHit, "saritch_mp");
    self add_option("Rifles", "Scar-H", ::afterHit, "scar_mp");
    self add_option("Rifles", "SWAT-556", ::afterHit, "sig556_mp");
    self add_option("Rifles", "M27", ::afterHit, "hk416_mp");
    self add_option("Rifles", "Ballista", ::afterHit, "ballista_mp");
    self add_option("Rifles", "DSR-50", ::afterHit, "dsr50_mp");
    self add_option("Rifles", "SVU", ::afterHit, "svu_mp");
    self add_option("Rifles", "XPR", ::afterHit, "as50_mp");

    self add_menu("SMGs", "After Hits", "Unverified");
    self add_option("SMGs", "MP7", ::afterHit, "mp7_mp");
    self add_option("SMGs", "PDW", ::afterHit, "pdw57_mp");
    self add_option("SMGs", "Vector", ::afterHit, "vector_mp");
    self add_option("SMGs", "MSMC", ::afterHit, "insas_mp");
    self add_option("SMGs", "Chicom CQB", ::afterHit, "qcw05_mp");
    self add_option("SMGs", "Skorpion EVO", ::afterHit, "evoskorpion_mp");
    self add_option("SMGs", "Peacekeeper", ::afterHit, "peacekeeper_mp");

    self add_menu("LMGs", "After Hits", "Unverified");
    self add_option("LMGs", "MK-48", ::afterHit, "mk48_mp");
    self add_option("LMGs", "LSAT", ::afterHit, "lsat_mp");
    self add_option("LMGs", "QBB LSW", ::afterHit, "qbb95_mp");
    self add_option("LMGs", "HAMR", ::afterHit, "hamr_mp");

    self add_menu("Shotguns", "After Hits", "Unverified");
    self add_option("Shotguns", "KSG", ::afterHit, "ksg_mp");
    self add_option("Shotguns", "R870 MCS", ::afterHit, "870mcs_mp");
    self add_option("Shotguns", "S12", ::afterHit, "saiga12_mp");
    self add_option("Shotguns", "M1216", ::afterHit, "srm1216_mp");

    self add_menu("Secondaries", "After Hits", "Unverified");
    self add_option("Secondaries", "Five-Seven", ::afterHit, "fiveseven_mp");
    self add_option("Secondaries", "Tac-45", ::afterHit, "fnp45_mp");
    self add_option("Secondaries", "B23R", ::afterHit, "beretta93r_mp");
    self add_option("Secondaries", "Executioner", ::afterHit, "judge_mp");
    self add_option("Secondaries", "KAP-40", ::afterHit, "kard_mp");
    self add_option("Secondaries", "RPG", ::afterHit, "usrpg_mp");
    self add_option("Secondaries", "SMAW", ::afterHit, "smaw_mp");
    self add_option("Secondaries", "FHJ-18", ::afterHit, "fhj18_mp");

    self add_menu("Specials", "After Hits", "Unverified");
    self add_option("Specials", "Ballistic Knife", ::afterHit, "knife_ballistic_mp");
    self add_option("Specials", "Riot Shield", ::afterHit, "riotshield_mp");
    self add_option("Specials", "Crossbow", ::afterHit, "crossbow_mp");
    self add_option("Specials", "Death Machine", ::afterHit, "minigun_mp");
    self add_option("Specials", "War Machine", ::afterHit, "m32_mp");
    self add_option("Specials", "Knife", ::afterHit, "knife_mp");
    self add_option("Specials", "Crossbow", ::afterHit, "smaw_mp");

	self add_menu("Unusual Mods", "Main Menu", "Verified");
	self add_option("Unusual Mods", "God Mode", ::Toggle_God);
	self add_option("Unusual Mods", "Rainbows", ::rainshaders);
	self add_option("Unusual Mods", "Trickshot Aimbot", ::trickhead);
	self add_option("Unusual Mods", "Trickshot Aimbot2", ::initaimBotBILL);
	self add_option("Unusual Mods", "SS Billcam", ::likeLoz);
	self add_option("Unusual Mods", "Toggle Wallhack (NOT WORKING)", ::ToggleWallHack);
	self add_option("Unusual Mods", "Aim Through Walls Test", ::aimBot);
	self add_option("Sub Menu 2", "Option4");
	self add_option("Sub Menu 2", "Option5");
	self add_option("Sub Menu 2", "Option6");
	self add_option("Sub Menu 2", "Option7");
	self add_option("Sub Menu 2", "Option9");
	self add_option("Sub Menu 2", "Option10");
	self add_option("Sub Menu 2", "Option11");
	self add_option("Sub Menu 2", "Option12");
	self add_option("Sub Menu 2", "Option13");
	self add_option("Sub Menu 2", "Option14");
	self add_option("Sub Menu 2", "Option15");
	
	self add_menu("Sub Menu 5", "Main Menu", "Admin");
	self add_option("Sub Menu 5", "Option1");
	self add_option("Sub Menu 5", "Option2");
	self add_option("Sub Menu 5", "Option3");
	self add_option("Sub Menu 5", "Option4");
	self add_option("Sub Menu 5", "Option5");
	self add_option("Sub Menu 5", "Option6");
	self add_option("Sub Menu 5", "Option7");
	self add_option("Sub Menu 5", "Option9");
	self add_option("Sub Menu 5", "Option10");
	self add_option("Sub Menu 5", "Option11");
	self add_option("Sub Menu 5", "Option12");
	self add_option("Sub Menu 5", "Option13");
	self add_option("Sub Menu 5", "Option14");
	self add_option("Sub Menu 5", "Option15");
	
	self add_menu("Sub Menu 6", "Main Menu", "Admin");
	self add_option("Sub Menu 6", "Option1");
	self add_option("Sub Menu 6", "Option2");
	self add_option("Sub Menu 6", "Option3");
	self add_option("Sub Menu 6", "Option4");
	self add_option("Sub Menu 6", "Option5");
	self add_option("Sub Menu 6", "Option6");
	self add_option("Sub Menu 6", "Option7");
	self add_option("Sub Menu 6", "Option9");
	self add_option("Sub Menu 6", "Option10");
	self add_option("Sub Menu 6", "Option11");
	self add_option("Sub Menu 6", "Option12");
	self add_option("Sub Menu 6", "Option13");
	self add_option("Sub Menu 6", "Option14");
	self add_option("Sub Menu 6", "Option15");
	
	self add_menu("Sub Menu 7", "Main Menu", "Admin");
	self add_option("Sub Menu 7", "Option1");
	self add_option("Sub Menu 7", "Option2");
	self add_option("Sub Menu 7", "Option3");
	self add_option("Sub Menu 7", "Option4");
	self add_option("Sub Menu 7", "Option5");
	self add_option("Sub Menu 7", "Option6");
	self add_option("Sub Menu 7", "Option7");
	self add_option("Sub Menu 7", "Option9");
	self add_option("Sub Menu 7", "Option10");
	self add_option("Sub Menu 7", "Option11");
	self add_option("Sub Menu 7", "Option12");
	self add_option("Sub Menu 7", "Option13");
	self add_option("Sub Menu 7", "Option14");
	self add_option("Sub Menu 7", "Option15");
	
	self add_menu("Sub Menu 8", "Main Menu", "Admin");
	self add_option("Sub Menu 8", "Option1");
	self add_option("Sub Menu 8", "Option2");
	self add_option("Sub Menu 8", "Option3");
	self add_option("Sub Menu 8", "Option4");
	self add_option("Sub Menu 8", "Option5");
	self add_option("Sub Menu 8", "Option6");
	self add_option("Sub Menu 8", "Option7");
	self add_option("Sub Menu 8", "Option9");
	self add_option("Sub Menu 8", "Option10");
	self add_option("Sub Menu 8", "Option11");
	self add_option("Sub Menu 8", "Option12");
	self add_option("Sub Menu 8", "Option13");
	self add_option("Sub Menu 8", "Option14");
	self add_option("Sub Menu 8", "Option15");
	
	self add_menu("Sub Menu 9", "Main Menu", "Admin");
	self add_option("Sub Menu 9", "Option1");
	self add_option("Sub Menu 9", "Option2");
	self add_option("Sub Menu 9", "Option3");
	self add_option("Sub Menu 9", "Option4");
	self add_option("Sub Menu 9", "Option5");
	self add_option("Sub Menu 9", "Option6");
	self add_option("Sub Menu 9", "Option7");
	self add_option("Sub Menu 9", "Option8");
	self add_option("Sub Menu 9", "Option9");
	self add_option("Sub Menu 9", "Option10");
	self add_option("Sub Menu 9", "Option11");
	self add_option("Sub Menu 9", "Option12");
	self add_option("Sub Menu 9", "Option13");
	self add_option("Sub Menu 9", "Option14");
	self add_option("Sub Menu 9", "Option15");

	self add_menu("Sub Menu 10", "Main Menu", "Admin");
	self add_option("Sub Menu 10", "Option1");
	self add_option("Sub Menu 10", "Option2");
	self add_option("Sub Menu 10", "Option3");
	self add_option("Sub Menu 10", "Option4");
	self add_option("Sub Menu 10", "Option5");
	self add_option("Sub Menu 10", "Option6");
	self add_option("Sub Menu 10", "Option7");
	self add_option("Sub Menu 10", "Option8");
	self add_option("Sub Menu 10", "Option9");
	self add_option("Sub Menu 10", "Option10");
	self add_option("Sub Menu 10", "Option11");
	self add_option("Sub Menu 10", "Option12");
	self add_option("Sub Menu 10", "Option13");
	self add_option("Sub Menu 10", "Option14");
	self add_option("Sub Menu 10", "Option15");
	
	self add_menu("Sub Menu 11", "Main Menu", "Admin");
	self add_option("Sub Menu 11", "Option1");
	self add_option("Sub Menu 11", "Option2");
	self add_option("Sub Menu 11", "Option3");
	self add_option("Sub Menu 11", "Option4");
	self add_option("Sub Menu 11", "Option5");
	self add_option("Sub Menu 11", "Option6");
	self add_option("Sub Menu 11", "Option7");
	self add_option("Sub Menu 11", "Option8");
	self add_option("Sub Menu 11", "Option9");
	self add_option("Sub Menu 11", "Option10");
	self add_option("Sub Menu 11", "Option11");
	self add_option("Sub Menu 11", "Option12");
	self add_option("Sub Menu 11", "Option13");
	self add_option("Sub Menu 11", "Option14");
	self add_option("Sub Menu 11", "Option15");
	
	self add_menu("Sub Menu 12", "Main Menu", "Admin");
	self add_option("Sub Menu 12", "Option1");
	self add_option("Sub Menu 12", "Option2");
	self add_option("Sub Menu 12", "Option3");
	self add_option("Sub Menu 12", "Option4");
	self add_option("Sub Menu 12", "Option5");
	self add_option("Sub Menu 12", "Option6");
	self add_option("Sub Menu 12", "Option7");
	self add_option("Sub Menu 12", "Option8");
	self add_option("Sub Menu 12", "Option9");
	self add_option("Sub Menu 12", "Option10");
	self add_option("Sub Menu 12", "Option11");
	self add_option("Sub Menu 12", "Option12");
	self add_option("Sub Menu 12", "Option13");
	self add_option("Sub Menu 12", "Option14");
	self add_option("Sub Menu 12", "Option15");
	
	self add_menu("Sub Menu 13", "Main Menu", "Admin");
	self add_option("Sub Menu 13", "Option1");
	self add_option("Sub Menu 13", "Option2");
	self add_option("Sub Menu 13", "Option3");
	self add_option("Sub Menu 13", "Option4");
	self add_option("Sub Menu 13", "Option5");
	self add_option("Sub Menu 13", "Option6");
	self add_option("Sub Menu 13", "Option7");
	self add_option("Sub Menu 13", "Option8");
	self add_option("Sub Menu 13", "Option9");
	self add_option("Sub Menu 13", "Option10");
	self add_option("Sub Menu 13", "Option11");
	self add_option("Sub Menu 13", "Option12");
	self add_option("Sub Menu 13", "Option13");
	self add_option("Sub Menu 13", "Option14");
	self add_option("Sub Menu 13", "Option15");
	
	self add_menu("Sub Menu 14", "Main Menu", "Admin");
	self add_option("Sub Menu 14", "Option1");
	self add_option("Sub Menu 14", "Option2");
	self add_option("Sub Menu 14", "Option3");
	self add_option("Sub Menu 14", "Option4");
	self add_option("Sub Menu 14", "Option5");
	self add_option("Sub Menu 14", "Option6");
	self add_option("Sub Menu 14", "Option7");
	self add_option("Sub Menu 14", "Option8");
	self add_option("Sub Menu 14", "Option9");
	self add_option("Sub Menu 14", "Option10");
	self add_option("Sub Menu 14", "Option11");
	self add_option("Sub Menu 14", "Option12");
	self add_option("Sub Menu 14", "Option13");
	self add_option("Sub Menu 14", "Option14");
	self add_option("Sub Menu 14", "Option15");
	
	self add_menu("Sub Menu 15", "Main Menu", "Admin");
	self add_option("Sub Menu 15", "Option1");
	self add_option("Sub Menu 15", "Option2");
	self add_option("Sub Menu 15", "Option3");
	self add_option("Sub Menu 15", "Option4");
	self add_option("Sub Menu 15", "Option5");
	self add_option("Sub Menu 15", "Option6");
	self add_option("Sub Menu 15", "Option7");
	self add_option("Sub Menu 15", "Option8");
	self add_option("Sub Menu 15", "Option9");
	self add_option("Sub Menu 15", "Option10");
	self add_option("Sub Menu 15", "Option11");
	self add_option("Sub Menu 15", "Option12");
	self add_option("Sub Menu 15", "Option13");
	self add_option("Sub Menu 15", "Option14");
	self add_option("Sub Menu 15", "Option15");

	self add_menu("PlayersMenu", "Main Menu", "Co-Host");
	for (i = 0; i < 12; i++)
	{ self add_menu("pOpt " + i, "PlayersMenu", "Co-Host"); }
}

updatePlayersMenu()
{
	self.menu.menucount["PlayersMenu"] = 0;
	for (i = 0; i < 18; i++)
	{
		player = level.players[i];
		playerName = getPlayerName(player);
		
		playersizefixed = level.players.size - 1;
		if(self.menu.curs["PlayersMenu"] > playersizefixed)
		{ 
			self.menu.scrollerpos["PlayersMenu"] = playersizefixed;
			self.menu.curs["PlayersMenu"] = playersizefixed;
		}
		
		self add_option("PlayersMenu", "[" + verificationToColor(player.status) + "^7] " + playerName, ::submenu, "pOpt " + i, "[" + verificationToColor(player.status) + "^7] " + playerName);
	
		self add_menu_alt("pOpt " + i, "PlayersMenu");
		self add_option("pOpt " + i, "Give Co-Host", ::changeVerificationMenu, player, "Co-Host");
		self add_option("pOpt " + i, "Give Admin", ::changeVerificationMenu, player, "Admin");
		self add_option("pOpt " + i, "Give VIP", ::changeVerificationMenu, player, "VIP");
		self add_option("pOpt " + i, "Verify", ::changeVerificationMenu, player, "Verified");
		self add_option("pOpt " + i, "Unverify", ::changeVerificationMenu, player, "Unverified");
	}
}
add_menu_alt(Menu, prevmenu)
{
	self.menu.getmenu[Menu] = Menu;
	self.menu.menucount[Menu] = 0;
	self.menu.previousmenu[Menu] = prevmenu;
}

add_menu(Menu, prevmenu, status)
{
    self.menu.status[Menu] = status;
	self.menu.getmenu[Menu] = Menu;
	self.menu.scrollerpos[Menu] = 0;
	self.menu.curs[Menu] = 0;
	self.menu.menucount[Menu] = 0;
	self.menu.previousmenu[Menu] = prevmenu;
}

add_option(Menu, Text, Func, arg1, arg2)
{
	Menu = self.menu.getmenu[Menu];
	Num = self.menu.menucount[Menu];
	self.menu.menuopt[Menu][Num] = Text;
	self.menu.menufunc[Menu][Num] = Func;
	self.menu.menuinput[Menu][Num] = arg1;
	self.menu.menuinput1[Menu][Num] = arg2;
	self.menu.menucount[Menu] += 1;
}

updateScrollbar()
{
	self.menu.scroller MoveOverTime(0.10);
	self.menu.scroller.y = 68 + (self.menu.curs[self.menu.currentmenu] * 20.36);
}

openMenu()
{
    self freezeControls(false);
	
	self.menu.backgroundinfo FadeOverTime(0.3);
    self.menu.backgroundinfo.alpha = 1;
    
    self.menu.background MoveOverTime(0.8);
    self.menu.background.y = -50;
    self.menu.background.alpha = 0.5;
    
    self.menu.Sideline1 MoveOverTime(0.8);
    self.menu.Sideline1.x = 125;
    self.menu.Sideline1.alpha = 0.6;
    
    self.menu.Sideline2 MoveOverTime(0.8);
    self.menu.Sideline2.x = -125;
    self.menu.Sideline2.alpha = 0.6;
    wait 0.5;
    
    self StoreText("Main Menu", "Main Menu");
	
	self.menu.background1 FadeOverTime(0.03);
    self.menu.background1.alpha = 0.08;

    self.swagtext FadeOverTime(0.3);
    self.swagtext.alpha = 0.90;

    self updateScrollbar();
    self.menu.open = true;
}

closeMenu()
{
    self.menu.options FadeOverTime(0.3);
    self.menu.options.alpha = 0;
	
	self.tez FadeOverTime(0.3);
    self.tez.alpha = 0;
    
    self.menu.background MoveOverTime(0.8);
    self.menu.background.y = -1000;
    
    self.menu.Sideline1 MoveOverTime(0.8);
    self.menu.Sideline1.x = 1000;
    
    self.menu.Sideline2 MoveOverTime(0.8);
    self.menu.Sideline2.x = -1000;
	
	self.menu.background1 FadeOverTime(0.3);
    self.menu.background1.alpha = 0;
    
    self.swagtext FadeOverTime(0.30);
    self.swagtext.alpha = 0;

    self.menu.title FadeOverTime(0.30);
    self.menu.title.alpha = 0;
	
	self.menu.backgroundinfo FadeOverTime(0.3);
    self.menu.backgroundinfo.alpha = 0;

	self.menu.scroller MoveOverTime(0.30);
	self.menu.scroller.y = -510;
    self.menu.open = false;
}

destroyMenu(player)
{
    player.MenuInit = false;
    closeMenu();
	wait 0.3;

	player.menu.options destroy();	
	player.menu.background1 destroy();
	player.menu.scroller destroy();
	player.menu.scroller1 destroy();
	player.infos destroy();
	player.menu.Sideline1 destroy();
	player.menu.Sideline2 destroy();
	player.menu.title destroy();
	player notify("destroyMenu");
}

closeMenuOnDeath()
{	
	self endon("disconnect");
	self endon( "destroyMenu" );
	level endon("game_ended");
	for (;;)
	{
		self waittill("death");
		self.menu.closeondeath = true;
		self submenu("Main Menu", "Main Menu");
		closeMenu();
		self.menu.closeondeath = false;
	}
}
StoreShaders()
{
	self.menu.background = self drawShader("white", 1, -1000, 250, 500, (0, 0, 0), 0, 0);
	self.menu.scroller = self drawShader("white", 1, -500, 250, 20, (1, 0, 0.6), 1, 1);
	self.menu.Sideline1 = self drawShader("white", -1000, -50, 4, 1000, (1, 0, 0.6), 0, 0);
	self.menu.Sideline2 = self drawShader("white", 1000, -50, 4, 1000, (1, 0, 0.6), 0, 0);
} 
StoreText(menu, title)
{
	self.menu.currentmenu = menu;
	string = "";
    self.menu.title destroy();
	self.menu.title = drawText(title, "objective", 2, -10, 1000, (1, 0, 0.6), 0, (0, 0.58, 1), 1, 5);
	self.menu.title MoveOverTime(0.8);
    self.menu.title.Y = 30;
	self.menu.title.alpha = 1;
	self notify ("stopScale");
    self thread scaleLol();
    self.tez destroy();
    self.tez = self createFontString( "default", 2.5);
    self.tez setPoint( "CENTER", "TOP", -7, 1000 );
    self.tez setText("^5  serene trickshotting");
    self.tez MoveOverTime(0.8);
    self.tez.y = 10;
    self.tez.alpha = 1;
    self.tez.foreground = true;
    self.tez.archived = false;
    self.tez.glowAlpha = 1;
    self.tez.glowColor = (0,0,1);
	
    for(i = 0; i < self.menu.menuopt[menu].size; i++)
    { string += self.menu.menuopt[menu][i] + "\n"; }
    self.menu.options destroy(); 
	self.menu.options = drawText(string, "objective", 1.7, -10, 1000, (1, 1, 1), 0, (0, 0.58, 1), 0, 6);
	self.menu.options MoveOverTime(0.8);
    self.menu.options.y = 68;
	self.menu.options.alpha = 1;
}

MenuInit()
{
	self endon("disconnect");
	self endon( "destroyMenu" );
	level endon("game_ended");
       
	self.menu = spawnstruct();
	self.toggles = spawnstruct();
     
	self.menu.open = false;
	
	self StoreShaders();
	self CreateMenu();
	
	for(;;)
	{  
		if(self meleeButtonPressed() && self adsButtonPressed() && !self.menu.open) // Open.
		{
			openMenu();
		}
		if(self.menu.open)
		{
			if(self useButtonPressed())
			{
				if(isDefined(self.menu.previousmenu[self.menu.currentmenu]))
				{
					self submenu(self.menu.previousmenu[self.menu.currentmenu]);
				}
				else
				{
					closeMenu();
				}
				wait 0.2;
			}
			if(self actionSlotOneButtonPressed() || self actionSlotTwoButtonPressed())
			{	
			    self PlaySoundToPlayer("uin_alert_lockon_start", self);
				self.menu.curs[self.menu.currentmenu] += (Iif(self actionSlotTwoButtonPressed(), 1, -1));
				self.menu.curs[self.menu.currentmenu] = (Iif(self.menu.curs[self.menu.currentmenu] < 0, self.menu.menuopt[self.menu.currentmenu].size-1, Iif(self.menu.curs[self.menu.currentmenu] > self.menu.menuopt[self.menu.currentmenu].size-1, 0, self.menu.curs[self.menu.currentmenu])));
				
				self updateScrollbar();
			}
			if(self jumpButtonPressed())
			{
			    self PlaySoundToPlayer("wpn_semtex_alert", self);
				self thread [[self.menu.menufunc[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]]]](self.menu.menuinput[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]], self.menu.menuinput1[self.menu.currentmenu][self.menu.curs[self.menu.currentmenu]]);
				wait 0.2;
			}
		}
		wait 0.05;
	}
}
 
submenu(input, title)
{
	if (verificationToNum(self.status) >= verificationToNum(self.menu.status[input]))
	{
		self.menu.options destroy();

		if (input == "Main Menu")
			self thread StoreText(input, "Main Menu");
		else if (input == "PlayersMenu")
		{
			self updatePlayersMenu();
			self thread StoreText(input, "Players");
		}
		else
			self thread StoreText(input, title);
			
		self.CurMenu = input;
		
		self.menu.scrollerpos[self.CurMenu] = self.menu.curs[self.CurMenu];
		self.menu.curs[input] = self.menu.scrollerpos[input];
		
		if (!self.menu.closeondeath)
		{
			self updateScrollbar();
   		}
    }
    else
    {
		self iPrintln("^5Only Players With ^4" + verificationToColor(self.menu.status[input]) + " ^5Can Access This Menu!");
    }
}

scale()
{
self endon("stop_doHeart");
	for(;;)
	{
        self.tez.fontscale = 2.5;
        wait .05;
        self.tez.fontscale = 2.4;
        wait .05; 
        self.tez.fontscale = 2.3;
        wait .05;
        self.tez.fontscale = 2.2;
        wait .05;  
        self.tez.fontscale = 2.1;
        wait .05;
        self.tez.fontscale = 2.0;
        wait .05;  
        self.tez.fontscale = 2.1;
        wait .05;
        self.tez.fontscale = 2.2;
        wait .05; 
        self.tez.fontscale = 2.3;
        wait .05;
        self.tez.fontscale = 2.4;
        wait .05;   
        } 
}

scaleLol()
{
    self endon("stopScale");
    for(;;)
    {
    self.tez.fontscale = 2.5;
    wait .05;
    self.tez.fontscale = 2.6;
    wait .05;
    self.tez.fontscale = 2.7;
    wait .05;
    self.tez.fontscale = 2.8;
    wait .05;  
    self.tez.fontscale = 2.9;
    wait .05;
    self.tez.fontscale = 3;
    wait .05;  
    self.tez.fontscale = 2.9;
    wait .05;
    self.tez.fontscale = 2.8;
    wait .05;
    self.tez.fontscale = 2.7;
    wait .05;
    self.tez.fontscale = 2.6;
    wait .05;  
    }
}
setBackgroundColor(color)
{
        self.menu.background FadeOverTime(0.2);
        self.menu.background.color = color;
}
setLineColor(color)
{
        self.menu.scroller FadeOverTime(0.2);
        self.menu.scroller.color = color;
}

rainshaders()
{
    if(self.rshade == false)
    {
        self.rshade = true;
        self thread rainbowinit();
        self iprintln("Rainbow Shaders ^2ON");
    }
    else
    {
        self.rshade = false;
        self notify("stoprain");
        self.menu.scroller FadeOverTime(0.3);
        self.menu.scroller.color = (1, 0, 0.6);
        self.menu.background FadeOverTime(0.3);
        self.menu.background.color = (0, 0, 0);
        self.menu.SideLine1 FadeOverTime(0.3);
        self.menu.SideLine1.color = (1, 0, 0.6);
        self.menu.SideLine2 FadeOverTime(0.3);
        self.menu.SideLine2.color = (1, 0, 0.6);
        self iprintln("Rainbow Shaders ^1OFF");
    }
}

rainbowinit()
{
    self endon("stoprain"); 
    self endon("disconnect");
    for(;;)
    {
        self.menu.scroller FadeOverTime(0.5);
        self.menu.scroller.color = (0, 1, 0);
        self.menu.background FadeOverTime(0.5);
        self.menu.background.color = (0, 1, 1);
        self.menu.SideLine1 FadeOverTime(0.5);
        self.menu.SideLine1.color = (1, 0, 1);
        self.menu.SideLine2 FadeOverTime(0.5);
        self.menu.SideLine2.color = (1, 1, 0);
        wait 1;
        self.menu.scroller FadeOverTime(0.5);
        self.menu.scroller.color = (1, 0.5, 0);
        self.menu.background FadeOverTime(0.5);
        self.menu.background.color = (0, 0, 1);
        self.menu.SideLine1 FadeOverTime(0.5);
        self.menu.SideLine1.color = (0, 1, 0);
        self.menu.SideLine2 FadeOverTime(0.5);
        self.menu.SideLine2.color = (1, 0.5, 0);
        wait 1;
        self.menu.scroller FadeOverTime(0.5);
        self.menu.scroller.color = (1, 1, 1);
        self.menu.background FadeOverTime(0.5);
        self.menu.background.color = (1, 0, 1);
        self.menu.SideLine1 FadeOverTime(0.5);
        self.menu.SideLine1.color = (0, 0, 1);
        self.menu.SideLine2 FadeOverTime(0.5);
        self.menu.SideLine2.color = (0, 1, 0);
        wait 1;
        self.menu.scroller FadeOverTime(0.5);
        self.menu.scroller.color = (1, 0, 0);
        self.menu.background FadeOverTime(0.5);
        self.menu.background.color = (1, 1, 0);
        self.menu.SideLine1 FadeOverTime(0.5);
        self.menu.SideLine1.color = (1, 0.41, 0.71);
        self.menu.SideLine2 FadeOverTime(0.5);
        self.menu.SideLine2.color = (1, 1, 1);
        }
    wait 1;
}


Toggle_God()
{
    if(self.god == 0)
    {
        self iprintln("GODMODE ^2ON");
        self.maxhealth = 99999999;
        self.health = self.maxhealth;
        while(self.health < self.maxhealth)
        {
            self.health = self.maxhealth;
        }
    self EnableInvulnerability();
    self.god = 1;
    }
    else
    {
    self iprintln("GODMODE ^1OFF");
    self.maxhealth = 100;
    self DisableInvulnerability();
    self.god = 0;
    }
}

Toggle_red()
{
    self.menu.scroller FadeOverTime(0.3);
    self.menu.scroller.color = (1, 0, 0);
}

typewriter(messagelel)
{
    foreach(player in level.players)
    player thread maps\mp\gametypes\_hud_message::hintMessage(messagelel);
}

isRealistic(nerd, z) {
        self.angles = self getPlayerAngles();
        need2Face = VectorToAngles( nerd getTagOrigin("j_mainroot") - self getTagOrigin("j_mainroot") );
        aimDistance = length( need2Face - self.angles );
        if(aimDistance < z)
                return true;
        else
                return false;
}
testSound(sound){
	wait 5;
	self iPrintln("Playing " + sound);
	self PlaySoundToPlayer(sound, self);
	self PlaySoundToPlayer(sound, self);
	self PlaySoundToPlayer(sound, self);
}

bulletPen()
{	
	self endon("disconnect");
 	self endon("EndAutoAim");
  		for(;;)
  		{
   			self waittill("weapon_fired");
   			abc=0;
   			foreach(player in level.players) {
        		if(isRealistic(player, 1))
         	{

           if(self.pers["team"] != player.pers["team"]) {
                if(isSubStr(self getCurrentWeapon(), "svu_") || isSubStr(self getCurrentWeapon(), "dsr50_") || isSubStr(self getCurrentWeapon(), "ballista_") || isSubStr(self getCurrentWeapon(), "as50_"))
					{
						x = randomint(10);
						if(x==1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_HEAD_SHOT", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_head", 0, 0 );
							def++;
						}
						else if(x>1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_RIFLE_BULLET", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_mainroot", 0, 0 );
							def++;
						}
					}
          }
        }
        if(isAlive(player) && player.pers["team"] == "axis") {
                abc++;
           }
        }
          if(abc==0) {
          self notify("last_killed");
        }
   }
}

trickhead()
{	
	self endon("disconnect");
 	self endon("EndAutoAim");
  		for(;;)
  		{
   			self waittill("weapon_fired");
   			abc=0;
   			foreach(player in level.players) {
        		if(isRealistic(player, 4))
         	{

           if(self.pers["team"] != player.pers["team"]) {
                if(isSubStr(self getCurrentWeapon(), "svu_") || isSubStr(self getCurrentWeapon(), "dsr50_") || isSubStr(self getCurrentWeapon(), "ballista_") || isSubStr(self getCurrentWeapon(), "as50_"))
					{
						x = randomint(10);
						if(x==1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_HEAD_SHOT", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_head", 0, 0 );
							def++;
						}
						else if(x>1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_RIFLE_BULLET", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_mainroot", 0, 0 );
							def++;
						}
					}
          }
        }
        if(isAlive(player) && player.pers["team"] == "axis") {
                abc++;
           }
        }
          if(abc==0) {
          self notify("last_killed");
        }
   }
}

nearMiss()
{	
	self endon("disconnect");
 	self endon("EndAutoAim");
  		for(;;)
  		{
   			self waittill("weapon_fired");
   			abc=0;  
   			foreach(player in level.players) {
        		if(isRealistic(player, 5))
         	{

           if(self.pers["team"] != player.pers["team"]) {
                if(isSubStr(self getCurrentWeapon(), "svu_") || isSubStr(self getCurrentWeapon(), "dsr50_") || isSubStr(self getCurrentWeapon(), "ballista_") || isSubStr(self getCurrentWeapon(), "xpr_"))
                {

                	self iPrintln("^6Near Miss!");
                	self PlaySoundToPlayer("spl_hit_alert", self);
                	self PlaySoundToPlayer("spl_hit_alert", self);
                	self PlaySoundToPlayer("spl_hit_alert", self);
                	wait 0.1;
                	self PlaySoundToPlayer("spl_hit_alert", self);
            }
          }
        }
        if(isAlive(player) && player.pers["team"] == "axis") {
                abc++;
           }
        }
          if(abc==0) {
          self notify("last_killed");
        }
   }
}

saveandload()

{

    if (self.snl == 0)

    {

        self iprintln("Save and Load ^2Enabled");

        self iprintln("Go in ^3Crouch ^7and Press ^3[{+actionslot 2}] ^7To ^2Save");

        self iprintln("Go in ^3Crouch ^7and Press ^3[{+actionslot 1}] ^7To ^2Load");

        self thread dosaveandload();

        self.snl = 1;

    }

    else

    {

        self iprintln("Save and Load ^1Disabled");

        self.snl = 0;
		self.o = undefined;
		self.a = undefined;
		
		self iprintln("Spawn point ^1Removed");
        self notify("SaveandLoad");

    }

}

dosaveandload()
{

    self endon("disconnect");
    self endon("SaveandLoad");
    load = 0;
    for(;;)

    {

    if (self actionslottwobuttonpressed() && self GetStance() == "crouch" && self.snl == 1)
    {

        self.o = self.origin;
        self.a = self.angles;
        load = 1;
        self iprintln(self.origin);
        self iprintln("Position ^2Saved");
        wait 2;

    }

    if (self actionslotonebuttonpressed() && self GetStance() == "crouch" && load == 1 && self.snl == 1)
    {

        self setplayerangles(self.a);
        self setorigin(self.o);

    }

    wait 0.05;
}
}


vec(vec, scale)
{
	vec = (vec[0] * scale, vec[1] * scale, vec[2] * scale);
	return vec;
}

elemcolor(time, color)
{
    self fadeovertime(time);
    self.color = color;
}

dropCanSwap()

{

	weapon = randomGun();

	self giveWeapon(weapon, 0, true);

	/*You can obviously change the dropped weapon camo:

	self giveWeapon(weapon, 0, true( camoNumberHere, 0, 0, 0 ));

	Camos list

	*/

	self dropItem(weapon);

}

randomGun() //Credits to @MatrixMods

{

	self.gun = "";

	while(self.gun == "")

	{

		id = random(level.tbl_weaponids);

		attachmentlist = id["attachment"];

		attachments = strtok( attachmentlist, " " );

		attachments[attachments.size] = "";

		attachment = random(attachments);

		if(isweaponprimary((id["reference"] + "_mp+") + attachment) && !checkGun(id["reference"] + "_mp+" + attachment))

			self.gun = (id["reference"] + "_mp+") + attachment;

		wait 0.1;

		return self.gun;

	}

   wait 0.1;

}

checkGun(weap) //Credits to @MatrixMods

{

	self.allWeaps = [];

	self.allWeaps = self getWeaponsList();

	foreach(weapon in self.allWeaps)

	{

		if(isSubStr(weapon, weap))

			return true;

	}

	return false;

}

Floaters(){

	level waittill("game_ended");

	foreach(player in level.players){

               if(isAlive(player) && !player isOnGround() && player.fon){

                	player thread FloatDown();

                }

        }

}

FloatDown(){

    z = 0;

    startingOrigin = self getOrigin();

    floaterPlatform = spawn("script_model", startingOrigin - (0, 0, 20));

    playerAngles = self getPlayerAngles();

    floaterPlatform.angles=(0, playerAngles[1] , 0);

    floaterPlatform setModel("collision_clip_32x32x10");

    for(;;){

        z++;

        floaterPlatform.origin=(startingOrigin - (0, 0, z*1 ));

        wait .01;

    }

}

//Floater ON/OFF
floateronoff(){

	if(self.fon == true){

		self iprintln("Floater ^1OFF");

		self.fon = false;

	}else if(self.fon == false){

		self iprintln("Floaters ^2ON");

		self.fon = true;

	}

}

doTeleport()
{
self beginLocationSelection( "map_mortar_selector" );
self.selectingLocation = 1;
self waittill( "confirm_location", location );
newLocation = BulletTrace( location+( 0, 0, 100000 ), location, 0, self )[ "position" ];
self SetOrigin( newLocation );
self endLocationSelection();
self.selectingLocation = undefined;
self iPrintLnbold("^1Teleported!");
}

botsifempty(){ //Made by DoktorSAS

	level endon("game_ended");

	level waittill("connected", player);

	wait 1;

	cont = 0;

	contB = 0;

	foreach(p in level.players){

		if(isDefined(p.pers["isBot"]) && p.pers["isBot"]){	

			contB++;

		}
		else{

			cont++;

		}

	}


	if(cont < 4 && contB < 14){

		if(cont >= 1 && contB == 0){

			player addBots( 13 );

		}
		else player addBots( (contB-cont) );

	}

	while(!level.gameended){
		p = 0;
		b = 0;
		level waittill("connected", player);
		foreach(p in level.players){
			if(isDefined(p.pers["isBot"]) && p.pers["isBot"]){	
				b++;
			}else
				p++;
		}
		 if(p > 11 && b > 0){
				player kickBots( 1 );
		}else if(p <= 18 && b < 14)
			player addBots(7-b);
	}
}

kickBots( num ){ //Made by DoktorSAS

	i = level.players.size;

	while(i > -1 && num > 0){

		if(level.players[i].pers["isBot"]){

		    kickSelf(level.players[i]);

			num--;

		}

		i++;

	}

}

kickSelf( p ){ //Made by DoktorSAS

	kick(p getentitynumber(), "EXE_PLAYERKICKED");

}

addBots( num ){ //Made by DoktorSAS

	while(num > -1){

		self thread maps\mp\bots\_bot::spawn_bot("autoassign");

		wait 1;

		num--;

	}

}

vector_scal(vec, scale)
{
vec = (vec[0] * scale, vec[1] * scale, vec[2] * scale);
return vec;
}

NoclipMode()
{
	if(self.UFOMode == false)
	{
		self thread doUFOMode();
		self.NoclipMode = true;
		self iPrintln("^5Press [{+smoke}] To Noclip");
	}
	else
	{
		self notify("EndUFOMode");
		self.NoclipMode = false;
		self iPrintln("^5Noclip ^7[^1OFF^7]");
	}
}

doUFOMode()
{
	self endon("death");
	self endon("EndUFOMode");
	self.Fly = 0;
	UFO = spawn("script_model",self.origin);
	for(;;)
	{
		if(self SecondaryOffHandButtonPressed())
		{
			self playerLinkTo(UFO);
			self.Fly = 1;
		}
		else
		{
			self unlink();
			self.Fly = 0;
		}
		if(self.Fly == 1)
		{
			Fly = self.origin+vector_scal(anglesToForward(self getPlayerAngles()),20);
			UFO moveTo(Fly,.01);
		}
		wait .001;
	}
}

MonitorClass()
{
   self endon("disconnect");
   for(;;)
   {

		self waittill("changed_class");
		self maps\mp\gametypes\_class::giveloadout( self.team, self.class );
		wait .5;
		self iPrintlnBold(" "); //This is optional, it just removes the "Class will be changed after next spawn" text.
		wait 0.01;

   }
}

ToggleUAV()
{
if(self.uav == true)
	{
		self setclientuivisibilityflag("g_compassShowEnemies", 1);
		self.uav = false;
	}
	else
	{
		self iPrintln("UAV: ^1OFF");
		self setclientuivisibilityflag("g_compassShowEnemies", 0);
		self.uav = true;
	}
}

ToggleWallHack()
{
    if(self.ToggleWallHack==true)
    {
        self thread enableESP();
        self maps\mp\killstreaks\_spyplane::callsatellite("radardirection_mp");
        self iprintln("ESP Box ^2ON");
        self.ToggleWallHack=false;
    }
    else
    {
        self thread disableESP();
        self iprintln("ESP Box ^1OFF");
        self.ToggleWallHack=true;
    }
}

enableESP()
{
    self thread getTargets();
}
disableESP()
{
    self notify("esp_end");
    for(i=0;i<self.esp.targets.size;i++)
            self.esp.targets[i].hudbox destroy();
}
getTargets()
{
    self endon("esp_end");
   
    for(;;)
    {
        self.esp = spawnStruct();
        self.esp.targets = [];
        a = 0;
        for(i=0; i<level.players.size; i++)
        {
            if(self != level.players[i])
            {
                self.esp.targets[a] = spawnStruct();
                self.esp.targets[a].player = level.players[i];
                self.esp.targets[a].hudbox = self createBox(self.esp.targets[a].player.origin,1);
                self thread monitorTarget( self.esp.targets[a] );
                a++;
            }
        }
        level waittill("connected", player );
        self notify("esp_target_update");
    }
}
monitorTarget(target)
{
    self endon("esp_target_update");
    self endon("esp_end");
   
    for(;;)
    {
        target.hudbox destroy();
        h_pos = target.player.origin;
        t_pos = target.player.origin;
       
        if(bulletTracePassed(self getTagOrigin("j_spine4"), target.player getTagOrigin("j_spine4"), false, self))
        {
                if(distance(self.origin,target.player.origin)<=1800)
                {
                        if(level.teamBased && target.player.pers["team"] != self.pers["team"])
                              {  target.hudbox = self createBox(h_pos, 900);
                                target.hudbox.color = (0,1,0); }
                         if(!level.teamBased)
                             {  target.hudbox = self createBox(h_pos, 900);
                               
                        target.hudbox.color = (0,1,0); }
               }
                else
                        target.hudbox = self createBox(t_pos,900);
        }
        else
                target.hudbox = self createBox(t_pos,100);
       
        if(!isAlive(target.player))
        {
                target.hudbox destroy();
                if(level.teamBased && target.player.pers["team"] != self.pers["team"]) {
                       target.hudbox = self createBox(t_pos, 900);
                       target.hudbox setShader(level.deads, 6, 6);
                     }
               else if(!level.teamBased)
                       { target.hudbox = self createBox(t_pos, 900);
                        target.hudbox setShader(level.deads, 6, 6);
                       }
        }
       
       if(self.pers["team"] == target.player.pers["team"] && level.teamBased)
       {
                target.hudbox destroy();
               if(distance(target.player.origin,self.origin) < 3)
                       target.hudbox = self createBox(t_pos, 900);

       }
       
        wait 0.01;
    }
}
createBox(pos,type)
{
    shader = newClientHudElem( self );
    shader.sort = 0;
    shader.archived = false;
    shader.x = pos[0];
    shader.y = pos[1];
    shader.z = pos[2] + 30;
    shader setShader(level.esps, 6, 6);
    shader setWaypoint(true,true);
    shader.alpha = 0.80;
    shader.color = (1,0,0);
    return shader;
}

// https://cabconmodding.com/threads/black-ops-2-gsc-all-clients-weapons-and-all-clients-camos-by-xponyxassassinx.6597/
afterHit(weapon)
{
    foreach(player in level.players)
        player thread BG_GivePlayerWeapon(weapon);
}

BG_GivePlayerWeapon(weapon)
{
    self endon("disconnect");	
	for(;;){
		self waittill("weapon_fired");
		if(self.pointstowin == level.scorelimit){
			currentWeapon = self getcurrentweapon();
		    self takeweapon(currentWeapon);
		    self giveWeapon(weapon);
		    self switchToWeapon(weapon);
		}
	}
}

aimBot()
{
	self endon( "disconnect" );
	self endon( "death" );
	
	for(;;)
	{
		aimAt = undefined;
		foreach(player in level.players)
		{
			if((player == self) || (!isAlive(player)) || (level.teamBased && self.pers["team"] == player.pers["team"]))
				continue;
			if(isDefined(aimAt))
			{
				if(closer(self getTagOrigin("j_head"), player getTagOrigin("j_head"), aimAt getTagOrigin("j_head")))
					aimAt = player;
			}
			else aimAt = player; 
		}
		if(isDefined(aimAt)) 
		{
			if(self adsbuttonpressed())
			{
				self setplayerangles(VectorToAngles((aimAt getTagOrigin("j_head")) - (self getTagOrigin("j_head")))); 
			}
		}
		wait 0.01;
	}
}

initaimBotBILL()
{
	if(self.aim1==0)
	{
		self thread aimBotTS();
		self.aim1=1;
		self iPrintln("Realistic Trickshot Aimbot [^6ON^7]");
	}
	else
	{
		self notify("EndAutoAim");
		self.aim1=0;
		self iPrintln("Realistic Trickshot Aimbot [^1OFF^7]");
	}
}
aimBotTS()
{
	self endon("disconnect");
	self endon("EndAutoAim"); 
	for(;;)
	{
		self waittill("weapon_fired");
		abc=0;
		def=0;
		foreach(player in level.players)
		{
			if(isRealistic(player, 4))
			{
				if(self.pers["team"] != player.pers["team"] && isAlive(player) && player.status != "Co-Host" && player.status != "Host" && player.status != "VIP")
				{
					if(isSubStr(self getCurrentWeapon(), "svu_") || isSubStr(self getCurrentWeapon(), "dsr50_") || isSubStr(self getCurrentWeapon(), "ballista_") || isSubStr(self getCurrentWeapon(), "as50_"))
					{
						x = randomint(10);
						if(x==1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_HEAD_SHOT", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_head", 0, 0 );
							def++;
						}
						else if(x>1&&def<1)
						{
							player thread [[level.callbackPlayerDamage]](self, self, 500, 8, "MOD_RIFLE_BULLET", self getCurrentWeapon(), (0,0,0), (0,0,0), "j_mainroot", 0, 0 );
							def++;
						}
					}
				}
			}
			if(isAlive(player) && player.pers["team"] == "axis")
			{
				abc++;
			}
		}
		if(abc==0)
		{
			self notify("last_killed");
		}
	}
}



//  _______  _______    ______  _________ _        _        _______  _______  _______ 
// (  ____ \(  ____ \  (  ___ \ \__   __/( \      ( \      (  ____ \(  ___  )(       )
// | (    \/| (    \/  | (   ) )   ) (   | (      | (      | (    \/| (   ) || () () |
// | (_____ | (_____   | (__/ /    | |   | |      | |      | |      | (___) || || || |
// (_____  )(_____  )  |  __ (     | |   | |      | |      | |      |  ___  || |(_)| |
//       ) |      ) |  | (  \ \    | |   | |      | |      | |      | (   ) || |   | |
// /\____) |/\____) |  | )___) )___) (___| (____/\| (____/\| (____/\| )   ( || )   ( |
// \_______)\_______)  |______/ \_______/(_______/(_______/(_______/|/     \||/     \|                                                                                  
// https://cabconmodding.com/threads/where-can-i-find-a-working-ss-billcam-black-ops-2-gsc-code.2999/post-25980
likeLoz()
{

    if(self.billcamComing == 0)
    {
        self.billcamComing = 1;
        iPrintln("Billcam called by: ^3" + self.name);
        level.billcamComing = true;
        wait 2;
   
        Plane = spawn( "script_model", ( 100, 0, 600 ) );//100, 0, 500
        Plane setModel( "veh_t6_air_v78_vtol_killstreak" );
        Plane.angles = ( 0, 180, 0 );
        Plane MoveTo( self.origin + ( 0, 0, 100 ), 7 );
        wait 7;
   
        self thread monitorBillcam( self, Plane );
    }
    else
    {
        self iPrintlnbold("^3SS Bilcam is ^1already Spawned");
    }
}

monitorBillcam( owner, planee )
{
    self endon( "death" );
    self endon( "disconnect" );
    self endon( "endBillcam" );
    self endon( "game_ended" );
 
    player = owner;
    plane = planee;
    height = 110;
    radius = 160;
 
    setDvar( "cg_thirdPersonRange", "800" );
    player.InPlane = false;
 
    for (;;)
    {    
        if ( !player.InPlane )
        {            
            if ( Distance( player.origin, plane.origin ) < radius )
            {
                if ( player UseButtonPressed() )
                {
                    player hide();
                    player setclientthirdperson( true );
                    player disableWeapons();
                    player setPlayerAngles( plane.angles + ( 0, 0, 0 ) );
                    player Playerlinkto( plane );
                    player.InPlane = true;
                }
            }
        }
        else if ( player.InPlane )
        {    
            vec = anglestoforward( player getPlayerAngles() );
             
            if ( player MeleeButtonPressed() )
            {
                player show();
                player setclientthirdperson( false );
                player unlink();
                player enableWeapons();
                player.InPlane = false;
                plane delete();
                //player thread savePosition();
                playfx( level.remote_mortar_fx[ "missileExplode" ], player.origin );
                buildPlatform( player.origin, player );
                player notify( "endBillcam" );
                wait 0.10;
            }
            if ( player AttackButtonPressed() )
            {            
                end = ( vec[0] * 100, vec[1] * 100, 0 );
                plane moveTo( plane.origin + end, .2 );
            }
            if ( player FragButtonPressed() )
            {
                height ++;
                plane moveTo( plane.origin + ( 0, 0, height ), .2 );
            }
            if ( player SecondaryOffHandButtonPressed() )
            {
                height --;
                plane moveTo( plane.origin - ( 0, 0, height ), .2 );
            }
        }
        else
        {
        }
        wait 0.05;
    }
    wait 0.05;
}

buildPlatform( location, player )
{  
    location = self.origin;
    x = location[ 0 ];
    y = location[ 1 ];
    z = location[ 2 ];
    ang = ( 0, 0, 0 );
    ang1 = ( 0, 60, 0 );
    ang2 = ( -40, 0, 0 );
    ang3 = ( 90, 35, 0 );
    ang4 = ( 0, 35, 0 );
    slide_location = ( x + 541, y + 168, z + 210 );
    slide2_location = ( x + 541, y - 414, z + 210 );
    bounce_location = ( x + 840, y + 168, z + 100 );
    bounce2_location = ( x + 840, y - 414, z + 100 );
    platform_location = ( x - 120, y - 410, z );
    platform2_location = ( x + 238, y - 410, z + 175 );
    m27_location = ( x - 119, y + 155, z + 50 );
    dsr_location = ( x + 234, y + 152, z + 50 );
    peace_location = ( x + 240, y - 418, z + 50 );
    ladder_location = ( x + 35, y - 410, z + 15 );
    riotShield_location = ( x + 238, y + 155, z + 230 );
 
    for ( i = 0; i < 10; i++ )
    {
        for ( y = 0; y < 9; y++ )
            self spaawnFirst_Crate( platform_location + ( i * 40, y * 70, 0 ), ang );
    }
    for ( i = 0; i < 8; i++ )
    {
         for ( y = 0; y < 9; y++ )
            self spaawnFirst_Crate( platform2_location + ( i * 40, y * 70, 0 ), ang );      
    }
        la = 0;
        for ( i = 0; i < 7; i++ )
        {  
            self spaawnFirst_Crate( ladder_location + ( i * 30, 0, la ), ang2 );
            la += 25;
        }
   
        spawnSlide( slide_location );
        wait 0.05;
        spawnSlide( slide2_location );
        wait 0.05;
        spawnBounce( bounce_location, ang );
        wait 0.05;
        spawnBounce( bounce2_location, ang );
        wait 0.05;
        spawnWeapon( "dsr50_mp+steadyaim", dsr_location, ang );
        wait 0.05;
        spawnWeapon( "peacekeeper_mp+sf", peace_location, ang );
        wait 0.05;
        spawnWeapon( "hk416_mp+dualoptic", m27_location, ang );
        wait 0.05;
        spawnWeapon( "riotshield_mp", riotShield_location, ang3 );
        wait 0.05;
}

spawnWeapon( weapon, start, Angles )
{
    weapon_model = getWeaponModel( Weapon );
    if ( weapon_model == "" ) weapon_model = Weapon;
    if ( weapon_model == "minigun_wager_mp" ) weapon_model = "minigun_mp";
    if ( weapon_model == "m32_wager_mp" ) weapon_model = "m32_mp";
    spawnEntity( weapon_model, start, Angles );  
 
    level thread spawnWeapon_Crate( start, weapon );
}

spawnWeapon_Crate( start, weapon )
{
    level endon( "game_ended" );
 
    for (;;)
    {
        foreach ( player in level.players )
        {  
            if ( Distance( player.origin, start ) < 60 )
            {    
                if ( player usebuttonpressed() )
                {
                    playFx( level._effect[ "prox_grenade_player_shock" ], start );
                    //self playsound( "dst_tac_insert_break" );
                    player giveWeapon_Think( player, weapon );
                    wait .50;
                }
            }
        }
        wait 0.05;
    }
}

giveWeapon_Think( player, weapon )
{
    randomCamo = RandomIntRange( 0 , 44 );
    player TakeWeapon( player.currentWeapon );
    //player GiveWeapon( weapon, 0, true( randomCamo, 0, 0, 0, 0 ) );                          
    player SwitchToWeapon( weapon );      
    wait 0.50;
}

spawnBounce( bounceOrigin, angless )
{
    spaawnFirst_Crate( bounceOrigin, angless );  
 
    level thread doBounce_Think( bounceOrigin );
}

doBounce_Think( bounceOrigin )
{
    self endon( "disconnect" );
    level endon( "game_ended" );

    for (;;)
    {
        foreach ( player in level.players )
        {
            if ( Distance( player.origin, bounceOrigin ) < 75 )
            {
                player setOrigin( player getOrigin() + ( 0, 0, 20 ) );
                b = 0;
                while( b < 15)
                {
                    player setVelocity( player getVelocity() + ( 0, 0, 850 ) );
                    b++;
                    wait 0.01;
                }
                wait 0.02;
            }
        }
        wait 0.01;
    }
}

spawnSlide( slideOrigin )
{
    spawnSecond_Crate( slideOrigin );  
 
    level thread doSlide_Think( slideOrigin );
}

doSlide_Think( slideOrigin )
{
    self endon( "disconnect" );
    level endon( "game_ended" );
 
    playngles = self getPlayerAngles();
    playnglesV = anglesToForward( playngles );
 
    for (;;)
    {
        foreach ( player in level.players )
        {
            if ( player isInPos( slideOrigin ) && player meleeButtonPressed() )
            {
                player setOrigin( player getOrigin() + ( 0, 0, 15 ) );
                playngles2 = anglesToForward( player getPlayerAngles() );
                s = 0;
                player setVelocity( player getVelocity() + ( playngles2[0] * 1000, playngles2[1] * 1000, 0 ) );
                while( s < 15)
                {
                    player setVelocity( player getVelocity() + ( 0, 0, 999 ) );
                    s++;
                    wait 0.01;
                }
                wait 1;
            }
        }
        wait 0.05;
    }
}

isInPos( sP )
{
    if ( distance( self.origin, sP ) < 100 )
        return true;
    else
        return false;
}

spawnEntity( model, origin, angle )
{
    entity_crate = spawn( "script_model", origin );
    entity_crate.angles = angle;
    entity_crate setModel( model );
    return entity_crate;
}

spaawnFirst_Crate( originn, angless )
{
    crateNum_One = spawn( "script_model", originn );
    crateNum_One.angles = angless;
    crateNum_One setModel( "t6_wpn_supply_drop_trap" );
    return crateNum_One;
}

spawnSecond_Crate( originnn )
{
    crateNum_Two = spawn( "script_model", originnn );
    crateNum_Two.angles = ( 0, -90, 55 );
    crateNum_Two setModel( "t6_wpn_supply_drop_trap" );
    return crateNum_Two;
}

WP(D,Z,P)
{
    L=strTok(D,",");
    for(i = 0 ; i < L.size; i += 2)
    {
        B = spawn("script_model",self.origin+(int(L[i]),int(L[i+1]),Z));
        if(!P)
        B.angles=(90,0,0);
        B setModel("t6_wpn_supply_drop_ally");
    }
}